# coding: utf-8

"""
    Suger API

    CRUD operations on a set of resources, including organizations, products, offers, entitlements, usage record groups for meterting, etc.

    The version of the OpenAPI document: 1.0
    Contact: support@suger.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from suger_sdk_python.models.azure_marketplace_deprecation_schedule import AzureMarketplaceDeprecationSchedule
from suger_sdk_python.models.azure_marketplace_resource_lifecycle_state import AzureMarketplaceResourceLifecycleState
from suger_sdk_python.models.azure_marketplace_resource_target import AzureMarketplaceResourceTarget
from suger_sdk_python.models.azure_marketplace_validation import AzureMarketplaceValidation
from typing import Optional, Set
from typing_extensions import Self

class AzureMarketplaceSubmission(BaseModel):
    """
    AzureMarketplaceSubmission
    """ # noqa: E501
    var_schema: Optional[StrictStr] = Field(default=None, alias="$schema")
    created: Optional[StrictStr] = Field(default=None, description="Date-time string")
    deprecation_schedule: Optional[AzureMarketplaceDeprecationSchedule] = Field(default=None, alias="deprecationSchedule")
    id: Optional[StrictStr] = None
    lifecycle_state: Optional[AzureMarketplaceResourceLifecycleState] = Field(default=None, alias="lifecycleState")
    product: Optional[StrictStr] = None
    resource_name: Optional[StrictStr] = Field(default=None, alias="resourceName")
    result: Optional[StrictStr] = None
    status: Optional[StrictStr] = None
    target: Optional[AzureMarketplaceResourceTarget] = None
    validations: Optional[List[AzureMarketplaceValidation]] = None
    __properties: ClassVar[List[str]] = ["$schema", "created", "deprecationSchedule", "id", "lifecycleState", "product", "resourceName", "result", "status", "target", "validations"]

    @field_validator('result')
    def result_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['succeeded', 'failed', 'pending']):
            raise ValueError("must be one of enum values ('succeeded', 'failed', 'pending')")
        return value

    @field_validator('status')
    def status_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['notStarted', 'running', 'completed']):
            raise ValueError("must be one of enum values ('notStarted', 'running', 'completed')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AzureMarketplaceSubmission from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of deprecation_schedule
        if self.deprecation_schedule:
            _dict['deprecationSchedule'] = self.deprecation_schedule.to_dict()
        # override the default output from pydantic by calling `to_dict()` of target
        if self.target:
            _dict['target'] = self.target.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in validations (list)
        _items = []
        if self.validations:
            for _item_validations in self.validations:
                if _item_validations:
                    _items.append(_item_validations.to_dict())
            _dict['validations'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AzureMarketplaceSubmission from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "$schema": obj.get("$schema"),
            "created": obj.get("created"),
            "deprecationSchedule": AzureMarketplaceDeprecationSchedule.from_dict(obj["deprecationSchedule"]) if obj.get("deprecationSchedule") is not None else None,
            "id": obj.get("id"),
            "lifecycleState": obj.get("lifecycleState"),
            "product": obj.get("product"),
            "resourceName": obj.get("resourceName"),
            "result": obj.get("result"),
            "status": obj.get("status"),
            "target": AzureMarketplaceResourceTarget.from_dict(obj["target"]) if obj.get("target") is not None else None,
            "validations": [AzureMarketplaceValidation.from_dict(_item) for _item in obj["validations"]] if obj.get("validations") is not None else None
        })
        return _obj


