# coding: utf-8

"""
    Suger API

    CRUD operations on a set of resources, including organizations, products, offers, entitlements, usage record groups for meterting, etc.

    The version of the OpenAPI document: 1.0
    Contact: support@suger.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from suger_sdk_python.models.azure_localized_time_range import AzureLocalizedTimeRange
from typing import Optional, Set
from typing_extensions import Self

class AzureProductVariantTrial(BaseModel):
    """
    AzureProductVariantTrial
    """ # noqa: E501
    date_time_range: Optional[AzureLocalizedTimeRange] = Field(default=None, alias="dateTimeRange")
    duration: Optional[StrictInt] = None
    duration_type: Optional[StrictStr] = Field(default=None, alias="durationType")
    type: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["dateTimeRange", "duration", "durationType", "type"]

    @field_validator('duration_type')
    def duration_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['Minute', 'Days', 'Months']):
            raise ValueError("must be one of enum values ('Minute', 'Days', 'Months')")
        return value

    @field_validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['NoTrial', 'TimedAccess', 'TimedUsage', 'Unlimited']):
            raise ValueError("must be one of enum values ('NoTrial', 'TimedAccess', 'TimedUsage', 'Unlimited')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AzureProductVariantTrial from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of date_time_range
        if self.date_time_range:
            _dict['dateTimeRange'] = self.date_time_range.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AzureProductVariantTrial from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "dateTimeRange": AzureLocalizedTimeRange.from_dict(obj["dateTimeRange"]) if obj.get("dateTimeRange") is not None else None,
            "duration": obj.get("duration"),
            "durationType": obj.get("durationType"),
            "type": obj.get("type")
        })
        return _obj


