# coding: utf-8

"""
    Suger API

    CRUD operations on a set of resources, including organizations, products, offers, entitlements, usage record groups for meterting, etc.

    The version of the OpenAPI document: 1.0
    Contact: support@suger.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from suger_sdk_python.models.metering_usage_record_group_by_key import MeteringUsageRecordGroupByKey
from typing import Optional, Set
from typing_extensions import Self

class BillableDimensionUsageDailyRevenue(BaseModel):
    """
    BillableDimensionUsageDailyRevenue
    """ # noqa: E501
    billable_metric_key: Optional[MeteringUsageRecordGroupByKey] = Field(default=None, alias="billableMetricKey")
    var_date: Optional[StrictStr] = Field(default=None, alias="date")
    quantity: Optional[Union[StrictFloat, StrictInt]] = None
    unique_property_items: Optional[Dict[str, Any]] = Field(default=None, alias="uniquePropertyItems")
    __properties: ClassVar[List[str]] = ["billableMetricKey", "date", "quantity", "uniquePropertyItems"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of BillableDimensionUsageDailyRevenue from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of billable_metric_key
        if self.billable_metric_key:
            _dict['billableMetricKey'] = self.billable_metric_key.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of BillableDimensionUsageDailyRevenue from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "billableMetricKey": MeteringUsageRecordGroupByKey.from_dict(obj["billableMetricKey"]) if obj.get("billableMetricKey") is not None else None,
            "date": obj.get("date"),
            "quantity": obj.get("quantity"),
            "uniquePropertyItems": obj.get("uniquePropertyItems")
        })
        return _obj


